﻿﻿using Oxide.Core;
using uLink;
using System.Linq;
using System;
using System.Collections.Generic;
using Newtonsoft.Json;
using Oxide.Game.Hurtworld;
using Oxide.Core.Configuration;
using Oxide.Core.Libraries;

namespace Oxide.Plugins
{
    [Info("ItemBlock", "рукожоп ферменс", 1.2)]
    [Description("ItemBlock")]
    public class ItemBlock : HurtworldPlugin
    {
        #region hooks
        void Init()
        {
            LoadConfig();
        }
        #endregion*
        //object GetConf(string Key, string Default) { return (Config[Key] == null || Config[Key].ToString() == "") ? Default : Config[Key]; }

        public PlayerInventory Inventory(PlayerSession session) => session.WorldPlayerEntity.GetComponent<PlayerInventory>();

        void OnPlayerInput(PlayerSession session, InputControls input)
        {
            DateTime date1 = new DateTime(C.year, C.month, C.day,C.hour, C.minut, 0);
            DateTime date2 = DateTime.Now;
            int result = DateTime.Compare(date1, date2);

            if (result > 0)
            {
                var inv = session.WorldPlayerEntity.GetComponent<PlayerInventory>();
                var inventory = session.WorldPlayerEntity.GetComponent<PlayerInventory>();
                var playerinv = session.WorldPlayerEntity.GetComponent<PlayerInventory>();
                var amanager = Singleton<AlertManager>.Instance;
                var itemmanager = Singleton<GlobalItemManager>.Instance;
                int n = 0;
                int yes = 0;
                int ful = 0;

                foreach (var cmd in C.ItemBlockId as Dictionary<string, object>)
                {
                    for (var isa = 0; isa < inventory.Capacity; isa++)
                    {
                        if (isa < 8)
                        {
                            if (inventory.GetSlot(isa) == null)
                            {
                            }
                            else if (inventory.GetSlot(isa).Item.ItemId == Convert.ToSingle(cmd.Value))
                            {
                                n = session.WorldPlayerEntity.GetComponent<PlayerInventory>().CountItem(Convert.ToInt32(cmd.Value));
                                yes = 1;
                            }
                        }

                        if (isa > 15 && yes == 1)
                        {
                            if (playerinv.Items[isa] == null)
                            {
                                ful = 1;
                                session.WorldPlayerEntity.GetComponent<PlayerInventory>().FindItem(Convert.ToInt32(cmd.Value), n);
                                hurt.SendChatMessage(session, null, C.message + Convert.ToInt32(date1.Subtract(date2).TotalMinutes) + " minut/y");

                                var item = itemmanager.GetItem(Convert.ToInt32(cmd.Value));
                                var iitem = new ItemInstance(item, n);
                                playerinv.Items[isa] = iitem;
                                amanager.ItemReceivedServer(iitem.Item, iitem.StackSize, session.Player);
                                playerinv.Invalidate(false);
                                return;
                            }
                            if (ful == 0 && isa >= inventory.Capacity - 1 && yes == 1)
                            {
                                session.WorldPlayerEntity.GetComponent<PlayerInventory>().FindItem(Convert.ToInt32(cmd.Value), n);
                                hurt.SendChatMessage(session, null, C.message+ Convert.ToInt32(date1.Subtract(date2).TotalMinutes) + " minut/y");
                                return;
                            }
                        }
                    }
                }
            }
        }
        //Dictionary<string, object> ItemBlockId = new Dictionary<string, object>();

        protected override void LoadDefaultConfig()
        {
            C.ItemBlockId.Add("C4", 144);
            C.ItemBlockId.Add("Pistol", 279);
            PrintWarning("Creating new config file for Running Man...");
        }

        protected new void LoadConfig()
        {
            GetConfig(ref C.hour, "ItemBlock", "Time", "Hour");
            GetConfig(ref C.minut, "ItemBlock", "Time", "Minut");
            GetConfig(ref C.day, "ItemBlock", "Time", "Day");
            GetConfig(ref C.month, "ItemBlock", "Time", "Month");
            GetConfig(ref C.year, "ItemBlock", "Time", "Year");
            GetConfig(ref C.message, "ItemBlock", "Message");
            GetConfig(ref C.ItemBlockId, "ItemBlock", "Items");

            SaveConfig();
        }

        private struct C
        {
            public static int hour = 15;
            public static int minut = 30;
            public static int day = 28;
            public static int month = 1;
            public static int year = 2018;
            public static string message = "<color=#FF6347>[ItemBlock]</color> Zablokowany na ";

            public static Dictionary<string, object> ItemBlockId = new Dictionary<string, object>()
            {
            };
        }

        private void GetConfig<T>(ref T variable, params string[] path)
        {
            if (path.Length == 0)
                return;

            if (Config.Get(path) == null)
            {
                Config.Set(path.Concat(new object[] { variable }).ToArray());
                PrintWarning($"Added field to config: {string.Join("/", path)}");
            }

            variable = (T)Convert.ChangeType(Config.Get(path), typeof(T));
        }
    }
}